routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Session;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

Route::get('/vue/{any?}', function () {
    return view('vue.index');
})->where('any', '[\/\w\.-]*');

Route::get('register/request', 'Auth\RegisterController@requestInvitation')->name('requestInvitation');
Route::post('invitations', 'InvitationsController@store')->middleware('guest')->name('storeInvitation');

Route::get('item/tag/{tag}', 'ItemController@index')->name('item.tag');

Route::group([
    'middleware' => ['auth', 'admin'],
    'prefix' => 'invitations',
], function () {
    Route::get('/', 'InvitationsController@index')->name('showInvitations');
});

Route::get('user/wait', function () {
    return view('user.wait');
})->name('user.wait');

Route::group(['middleware' => ['auth', 'approval']], function () {

    Route::get('/home', 'HomeController@index')->name('home');

    Route::get('/calendar', function () {
        return view('layouts.admin');
    })->name('calendar.index');

    Route::get('/profile', 'ProfileController@index')->name('profile');
    Route::put('/profile', 'ProfileController@update')->name('profile.update');
    
    Route::resource('project', 'ProjectController');
    Route::resource('user', 'UserController');
    Route::resource('item', 'ItemController');
    Route::resource('leave', 'LeaveController'); 

    Route::get('/', 'HomeController@index');

});

Route::group(['prefix' => 'api', 'middleware' => ['auth']], function () {
    Route::resource('tasks', 'TaskController');
    Route::get('/user/{id}/projects', 'UserController@getProjectsById')->name('user.projects');
    Route::get('/department/{id}/projects', 'DepartmentController@getProjectsById')->name('department.projects');
    Route::get('/user/all', 'UserController@getUsers')->name('user.all');
    Route::get('/user/get/{id}', 'UserController@getUser')->name('user.get');
    Route::get('/project/all', 'ProjectController@getProjects')->name('project.all');
    Route::get('/project/get/{id}', 'ProjectController@getProject')->name('project.get');
    Route::post('/project/search', 'ProjectController@search')->name('project.search');
    Route::get('/department/all', 'DepartmentController@getDepartments')->name('department.all');
    Route::get('/project/{id}/follow', 'ProjectController@followProject')->name('project.follow');
    Route::get('/project/{id}/unfollow', 'ProjectController@unFollowProject')->name('project.unfollow');
    Route::get('/item/all', 'ItemController@getItems')->name('item.all');
    Route::get('/item/get/{id}', 'ItemController@getItem')->name('item.get');
    Route::get('/tag/all', 'TagController@getTags')->name('tag.all');
    Route::get('/leave/get/{id}', 'LeaveController@getLeave')->name('leave.get');
    Route::get('/leave/all', 'LeaveController@getLeaves')->name('leave.all');
    Route::get('/leave/{id}/approval', 'LeaveController@approval')->name('leave.approval');
    Route::get('/user/{id}/approve', 'UserController@approve')->name('user.approve');

    Route::get('/classifier/list/{table}/{field}', 'ClassifierController@list')->name('classifier.list');
});

Route::get('/about', function () {
    return view('about');
})->name('about');

Route::get('/locale/{locale}', function ($locale) {
    Session::put('locale', $locale);
    return redirect()->back();
})->name('locale');

Auth::routes();

Route::get('register', 'Auth\RegisterController@showRegistrationForm')
    ->name('register')
    ->middleware('hasInvitation');

Route::prefix('login')->group(function () {
    Route::get('/{provider}', 'Auth\LoginController@redirectToProvider')->name('login.provider');
    Route::get('/{provider}/callback', 'Auth\LoginController@handleProviderCallback')->name('login.provider.callback');
});

app/User.php
<?php

namespace App;

use App\Project;
use App\Department;
use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable, HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'first_name', 'last_name', 'email', 'password', 'avatar', 'approved_at'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    protected $appends = ['full_name', 'department'];

    /**
     * Get the user's full name.
     *
     * @return string
     */
    public function getFullNameAttribute()
    {
        return "{$this->first_name} {$this->last_name}";
    }

    public function getDepartmentAttribute()
    {
        return $this->department()->first();
    }

    public function projects()
    {
        return $this->belongsToMany('App\Project', 'projects_users', 'user_id', 'project_id');
    }

    public function own_projects()
    {
        return $this->hasMany('App\Project', 'owner_id', 'id');
    }

    public function department()
    {
        return $this->belongsTo('App\Department', 'department_id', 'id');
    }

    public function leaves()
    {
        return $this->hasMany('App\Leave', 'user_id', 'id');
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class UserController extends Controller
{

    public function __construct()
    {
        $this->middleware('admin')->only(['create', 'store', 'edit', 'update', 'approval']);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('layouts.admin');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('layouts.admin');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validated = $request->validate([
            'email' => 'required|unique:users,email|max:100',
            'image' => 'nullable|sometimes|image|mimes:jpg,png,jpeg,gif|max:2048',
        ]);

        $model = new User;

        $model->name = $request->first_name . ' ' . $request->last_name;
        $model->first_name = $request->first_name;
        $model->last_name = $request->last_name;
        $model->nick_name = $request->nick_name;
        $model->email = $request->email;
        $model->department_id = $request->department_id;
        $model->role = $request->role;
        $model->password = '$2y$10$92IXUNpkjO0rOQ5byMi.Ye4oKoEa3Ro9llC/.og/at2.uheWG/igi'; // password
        $model->approved_at = now();

        if ($request->file('image')) {
            $model->avatar = basename($request->file('image')->store('users', 'public'));
        }

        $model->save();
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return view('layouts.admin');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('layouts.admin');
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, User $user)
    {
        $model = $user;

        $validated = $request->validate([
            'image' => 'nullable|sometimes|image|mimes:jpg,png,jpeg,gif|max:2048',
        ]);

        $model->name = $request->first_name . ' ' . $request->last_name;
        $model->first_name = $request->first_name;
        $model->last_name = $request->last_name;
        $model->nick_name = $request->nick_name;
        $model->department_id = $request->department_id;
        $model->role = $request->role;

        if ($request->file('image')) {
            Storage::delete("/public/users/" . $model->avatar);
            $model->avatar = basename($request->file('image')->store('users', 'public'));
        }

        if ($request['reset_image'] === 'true') {
            Storage::delete("/public/users/" . $model->avatar);
            $model->avatar = null;
        }

        $model->save();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function getProjectsById($id)
    {
        $ownProjects = User::findOrFail($id)->own_projects()->get();
        $projects = User::findOrFail($id)->projects()->get();
        return $ownProjects->merge($projects);
    }

    public function getUser($id)
    {
        return User::findOrFail($id);
    }

    public function getUsers(Request $request)
    {
        $user = new User;

        if ($request->query('search')) {
            $search = $request->query('search');
            $user = $user->where('first_name', 'like', '%' . $search . '%')
                    ->orWhere('last_name', 'like', '%' . $search . '%')
                    ->orWhere('nick_name', 'like', '%' . $search . '%')
                    ->orWhere('email', 'like', '%' . $search . '%')
                    ->orWhereHas('department', function($q) use ($search) {
                        $q->where('name', 'like', '%' . $search . '%');
                    });
        }

        if ($request->query('limit')) {
            $user = $user->take($request->query('limit'));
        }

        return $user->orderBy('updated_at', 'desc')->get();
    }

    public function approve($id, Request $request)
    {
        $model = User::findOrFail($id);
        $model->approved_at = now();
        $model->save();
    }
}

resources/views/user/create.blade.php
@extends('layouts.admin')

@section('main-content')

<user-form   title="User Create"
                action="create"
                back-url="{{ route('user.index') }}"
                save-url="{{ route('user.store') }}">
</user-form>

@endsection

resources/views/user/index.blade.php
@extends('layouts.admin')

@section('main-content')


<div class="container">
    
    <b-card>
        <div class="table-responsive">
            <table class="table">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>{{ __('First Name') }}</th>
                        <th>{{ __('Last Name') }}</th>
                        <th>{{ __('Nick Name') }}</th>
                        <th>{{ __('Email') }}</th>
                        <th>{{ __('Department') }}</th>
                    </tr>
                </thead>
                <tbody>
                    @forelse ($users as $user)
                    <tr>
                        <td scope="row"><a href="{{ route('user.create') }}">{{ $loop->iteration }}</a></td>
                        <td>{{ $user->first_name }}</td>
                        <td>{{ $user->last_name }}</td>
                        <td>{{ $user->nick_name }}</td>
                        <td>{{ $user->email }}</td>
                        <td>{{ $user->department->name }}</td>
                    </tr>
                    @empty
                        <tr>
                            <td class="text-center" colspan="6">{{ __('There is no user record') }}</td>
                        </tr>
                    @endforelse
                </tbody>
            </table>
        </div>
    </b-card>
</div>

@endsection

resources/views/user/wait.blade.php
@extends('layouts.auth')

@section('main-content')
<div class="container">
    <div class="card o-hidden border-0 shadow-lg my-5">
        <div class="card-body p-0">
            <div class="row">
                <div class="col-12">

                    <div class="text-center p-5">
                        <h2 class="text-gray-800 mb-5">Waiting For Approval</h2>
                        <h4 class="text-gray-600 mb-0">You have to wait until admin allow you to use the website.</h3>
                            <a href="/home">← Back to Dashboard</a>
                            |
                            <a href="{{ route('logout') }}"
                                onclick="event.preventDefault(); document.getElementById('logout-form').submit();">Logout
                                →</a>
                            <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                @csrf
                            </form>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>
@endsection